package com.hzya.frame.plugin.oa.praybill.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.plugin.oa.praybill.service.IRequisitionOrderPluginService;
import com.hzya.frame.seeyon.enums.ColEventTypeEnum;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.LinkedList;
import java.util.List;

/**
 * @Description OA请购单传NCC
 * @Author xiangerlin
 * @Date 2025/5/21 17:44
 **/
public class RequisitionOrderPluginServiceImpl implements IRequisitionOrderPluginService {
    Logger logger = LoggerFactory.getLogger(IRequisitionOrderPluginService.class);
    /**
     * 请购单同步到ncc
     *
     * @param requestJson
     * @return
     */
    @Override
    public JsonResultEntity sync2ncc(JSONObject requestJson) {
        //数据源编码
        String datasourceCode = requestJson.getString("sourceCode");
        String headersStr = requestJson.getString("headers");//请求头
        String formAppId = requestJson.getString("formApp");
        String eventType = requestJson.getString("eventType");
        JSONObject formmainData = requestJson.getJSONObject("formmainTableName");
        JSONArray forsonData = requestJson.getJSONArray("forsonTableName");
        Assert.notEmpty(formAppId,"formAppId不能为空");
        Assert.notEmpty(eventType,"eventType不能为空");
        Assert.notEmpty(headersStr,"headers不能为空");
        //流程结束
        if (ColEventTypeEnum.ONPROCESSFINISHED.getType().equals(eventType)){
            JSONObject praybill = new JSONObject();
            praybill.put("pk_org",formmainData.getString("field0005"));//库存组织
            praybill.put("vbillcode",formmainData.getString("field0001"));//请购单号
            praybill.put("dbilldate",formmainData.getString("field0004"));//请购日期
            praybill.put("bsctype",formmainData.getString("field0009"));//委外
            praybill.put("pk_planpsn",formmainData.getString("field0010"));//计划员
            praybill.put("pk_plandept_v",formmainData.getString("field0011"));//计划部门
            praybill.put("vmemo",formmainData.getString("field0013"));//备注
            praybill.put("fbillstatus",formmainData.getString("field0012"));//单据状态
            praybill.put("billmaker", formmainData.getString("field0002"));//制单人
            praybill.put("dmakedate", formmainData.getString(""));//制单日期
            praybill.put("ctrantypeid", formmainData.getString("field0006"));//请购类型
            List<JSONObject> parybillList = new LinkedList<>();
            praybill.put("pk_praybill_b",parybillList);

        }
        return BaseResult.getSuccessMessageEntity("请购单推NCC成功");
    }
}
